(* ========================================================================= *)
(* Axioms for extensionality and classical logic                             *)
(*                                                                           *)
(*       Chantal Keller, Laboratoire d'Informatique de Polytechnique         *)
(*                                                                           *)
(*    (c) Copyright, Laboratoire d'Informatique de Polytechnique 2010        *)
(*              (c) Copyright, Chantal Keller 2010                           *)
(* ========================================================================= *)


Require Import ssreflect.

Require Export FunctionalExtensionality ClassicalEpsilon.
Require Import ClassicalFacts.


Axiom prop_extensionality : prop_extensionality.


Lemma prop_degeneracy : prop_degeneracy.
Proof.
  exact (prop_ext_em_degen prop_extensionality classic).
Qed.


Lemma axiom_K : forall A (x: A) (h: x = x), h = refl_equal x.
Proof (fun A x h => Classical_Prop.proof_irrelevance (x = x) h
  (refl_equal x)).
